--- src/irc_server.c.orig	2012-06-15 12:41:29.000000000 -0500
+++ src/irc_server.c	2012-06-15 12:49:14.000000000 -0500
@@ -338,7 +338,7 @@
      somewhere that will tell us */
   if (!p->hostname) {
     struct sockaddr_in sock_addr;
-    int len;
+    socklen_t len;
 
     len = sizeof(struct sockaddr_in);
     if (!getsockname(p->server_sock, (struct sockaddr *)&sock_addr, &len)) {
@@ -700,7 +700,13 @@
               free(s);
 
               /* Was in the squelch list, so remove it and stop looking */
-              s = (l ? l->next : p->squelch_modes) = n;
+              if (l) {
+                l->next = n;
+                s = l->next;
+              } else {
+                p->squelch_modes = n;
+                s = p->squelch_modes;
+              }
               squelch = 1;
               break;
             } else {
@@ -741,7 +747,13 @@
               free(s);
 
               /* Was in the squelch list, so remove it and stop looking */
-              s = (l ? l->next : p->squelch_modes) = n;
+              if (l) {
+                l->next = n;
+                s = l->next;
+              } else {
+                p->squelch_modes = n;
+                s = p->squelch_modes;
+              }
               squelch = 1;
               break;
             } else {
@@ -1081,7 +1093,7 @@
         } else if (!strcmp(cmsg.cmd, "DCC")
                    && p->conn_class->dcc_proxy_incoming) {
           struct sockaddr_in vis_addr;
-          int len;
+          socklen_t len;
 
           /* We need our local address to do anything DCC related */
           len = sizeof(struct sockaddr_in);
